program FIXTREE;
(*
  Written by Jay Baker, CIS ID 73530,3146
  Anyone may use this program, but I would appreciate receiving back
  any improvements.
*)

  procedure setindent(indentsize:integer;var indent:string);
  begin
    fillchar(indent[1],indentsize,' ');
    byte(indent[0]):=indentsize;
    end; {setindent}

  function then_line(s:string):integer;
  var
    i,j:integer;
  begin
    then_line:=0;
    j:=pos('Then ',s);
    if j>0 then begin
      i:=1;
      while (i<length(s)) and (s[i]=' ') do inc(i);
      if i=j then
        then_line:=i;
      end;
    end; {then_line}

var
  t1,t2:text;
  s:string;
  indent:string;
  i:integer;

begin
  if ParamStr(1)='' then begin
    writeln('FIXTREE tree_output_name');
    writeln('FIXTREE expects to read a file that ends with .TRE, and');
    writeln('write one that ends with .TRF');
    writeln('First run: OVDTREE myapp >myapp.tre');
    writeln('Next run:  FIXTREE myapp');
    halt;
    end;
  assign(t1,ParamStr(1)+'.tre');
  reset(t1);
  assign(t2,ParamStr(1)+'.trf');
  rewrite(t2);
  while not eof(t1) do begin

    readln(t1,s);
    {put in extra blank line before tree}
    if      pos('Event Tree for Field ',s)=1 then writeln(t2)
    else if pos('Value Tree for Field ',s)=1 then writeln(t2)
    else if pos('Event Tree for Item',  s)=1 then writeln(t2)
    else begin
      {fix indenting for THEN clause}
      i:=then_line(s);
      if i>0 then
        setindent(i+4,indent)
      else if (s<>'') and (s[1]<>' ') then
        s:=indent+s;
      end;

    writeln(t2,s);

    end;
  close(t1);
  close(t2);
  end.
